Strict

Const debug=0

'Strict

'Import "Tini.bmx"
'Import sidesign.minib3d

Type Tpoint
	Field x,y
EndType

Type TMap
	'Maptypen
	Const CDungeon%=0
	
	'Maparray inhalte
	Const CMapWand%=0
	Const CMapWeg%=1

	'Map Erstellungsparameter
	Global VMapRaumheufigkeit%
	Global VMapRaumgroesse%
	Global VMapWegmaxlaenge%
	Global VMapWegminlaenge%
	Global VMapWeganz%
	Global VMapWegminbreite%
	Global VMapWegmaxbreite%
	Global punktliste:TList

	Global array:Byte[2048,2048]
	
	Function Create(Typ%=CDungeon%)
		If debug=1 Then Print "M-Maperstellung"
		'Delete all Array entrys
		If debug=1 Then Print "M-Lschen"
		Local x:Int
		Local y:Int
		For x = 0 To 2047
			For y = 0 To 2047
				Tmap.array[x,y] = CMapWand%
			Next
		Next

		'Create Dungeon By Type
		If debug=1 Then Print "M-Typ Laden"
		Loadtype(Typ)
		If debug=1 Then Print "M-Map Typ erstellen"
		Select Typ
		Case CDungeon%
			Createdungeon()
		Default
			Loadtype(CDungeon%)
			Createdungeon()
		EndSelect
		
	End Function
	
	Function Createdungeon()
		'Weg an position 1 beginnen
		If debug=1 Then Print "CD-CreateDungeon"
		Local x%=1024
		Local y%=1024
		
		'Wege erstellen
		If debug=1 Then Print "CD-Wegerstellen"
		Local i
		For i = 0 To VMapWeganz
			
			Local xalt:Int=x
			Local yalt:Int=y
			
			'Weg bestimmen
			Local Side:Int
	
			side = Rand (0,359)
			Local weite=Rand(VMapWegminlaenge%,VMapWegmaxlaenge%)
				
			x=x+Sin(side)*weite
			y=y+Cos(side)*weite
	
			If xalt <2 And Sin(side) <0 Then x=xalt-Sin(side)*weite
			If yalt <2 And Cos(side) <0 Then y=yalt-Cos(side)*weite
			If xalt >2045 And Sin(side) >0 Then x=xalt-Sin(side)*weite
			If yalt >2045 And Cos(side) >0 Then y=yalt-Cos(side)*weite
			
			
			'Weg in den Abgrenzungen der Map
			If x < 1 Then x=1
			If x > 2046 Then x=2046
			If y <1 Then y=1
			If y >2046 Then y=2046
			
			'Weg ziehen (von xalt zu x neu und yalt zu yneu)
			Repeat
				'Weg setzten
				Local wayx%,wayy%
				Local Waybreite%=Rand(VMapWegminBreite,VMapWegmaxBreite)
				For wayx=xalt To xalt+Waybreite%
					For wayy=yalt To yalt+Waybreite%
						Local wegx%=wayx
						Local wegy%=wayy
						
						If wegx < 1 Then wegx=1
						If wegx > 2046 Then wegx=2046
						If wegy <1 Then wegy=1
						If wegy >2046 Then wegy=2046
						
						Tmap.array[wegx,wegy]=CMapWeg%
					Next
				Next
				If xalt < x Then xalt = xalt +1
				If xalt > x Then xalt = xalt -1
				If yalt < y Then yalt = yalt +1
				If yalt > y Then yalt = yalt -1
				
				'Raum erstellen
				If Rand (VMapRaumheufigkeit%) = 1 Then
					Local Raumgroesse% =Rand(2,VMapRaumgroesse%)
					Local mx:Int
					Local my:Int
					For mx = x-Raumgroesse% To x+Raumgroesse%
						For my = y-Raumgroesse% To y+Raumgroesse%
							Local lx%=mx,ly%=my
							If lx < 1 Then lx=1
							If lx > 2046 Then lx=2046
							If ly <1 Then ly=1
							If ly >2046 Then ly=2046
							
							Tmap.array[lx,ly]=CMapWeg%
						Next
					Next
				EndIf
				
			Until  (xalt = x) And (yalt = y)
		Next

	EndFunction
	
	Function dekoratemap(size%=4)
		If debug=1 Then Print "L-Dekorate Map"
		Local x,y
		Local m,mx,my,t

		For x = 1 To 2046
			For y = 1 To 2046
				If getpos(X,Y)=1 Then
					m=0
					For mx = x-size To x+size
						For my = y-size To y+size
							m=m+getpos(mX,mY)
						Next
					Next
					m=m/3
					If tmap.array[x,y]>0 Then
						If m<0 Then m=0
						'Print tmap.array[x,y] + " --> " + (tmap.array[x,y] And (m Shl 3))
						tmap.array[x,y]=(tmap.array[x,y] + (m Shl 3))
					EndIf
				EndIf
			Next
		Next
	End Function
	
	Function bereichmap(size%=20)
		If debug=1 Then Print "L-bereich Map"
		Local x,y
		Local m,mx,my,t,n
		For x = 0 To 2047 Step 64
			For y = 0 To 2047 Step 64
				m=0
				n=0
				For mx=x To x+63
					For my=y To y+63
						If getpos(mx,my)=1 Then
							m=m+1
						Else
							If get_part_of_byte(tmap.array[mx,my],5,6)=1 Shl 1 Then n=n+1
						EndIf
						
					Next
				Next
				
				If m< 2000 Then
					If n > 1000 Then' Strand
						t=3
					Else ' Wald
						t=0
					EndIf
				EndIf
				If m>1999 Then
					If n > 1000 Then' Strand
						t=3
					Else ' Lichtung
						t=2
					EndIf
				EndIf
				For mx=x To x+63
					For my=y To y+63
						'If getpos(mx,my)=1 Then 
						If get_part_of_byte(tmap.array[mx,my],5,6)=0 Then tmap.array[mx,my]=(tmap.array[mx,my] + (t Shl 1))
					Next
				Next
				
			
			Next
		Next
	End Function
	
	Function smoothmap(size%,anz%=1)
		If debug=1 Then Print "L-Smooth map"
		Local x,y
		Local m,mx,my,t
		For t = 1 To anz
			For x = 1 To 2046
				For y = 1 To 2046
					m=0
					For mx = x-size To x+size
						For my = y-size To y+size
							m=m+getpos(mX,mY)
						Next
					Next
					If m > 0 Then
						tmap.array[x,y]=1
					Else
						tmap.array[x,y]=0
					EndIf
				Next
			Next
		Next
	End Function
	
	Function checkmap()
		If debug=1 Then Print "L-Check map"
		Local x,y
		Local m,mx,my
		mx=1024
		mx=1024
		m=0
		For mx = 1000 To 1100
			For my = 1000 To 1100
				If getpos(mx,my)=1 And m=0 Then
					tmap.array[mx,my]=((tmap.array[mx,my]) + (1 Shl 2))
					Checkpoint(mX,mY,1)
					m=1
				EndIf
			Next
		Next

		For x = 0 To 2047
			For y = 0 To 2047
				If get_part_of_byte(tmap.array[x,y],5,5) Shr 2 = 0 Then
					tmap.array[x,y]=0
				Else
					tmap.array[x,y]=1
				EndIf
			Next
		Next
	End Function
	
	Function Checkpoint(X,Y,T)
		If punktliste = Null Then punktliste=New TList
		Local z:tpoint=New Tpoint
		z.x=x
		z.y=y
		punktliste.addlast(z)
		Local i,s[4,2],mx,my
		s[0,0]=-1
		s[0,1]=0
		
		s[1,0]=0
		s[1,1]=-1
		
		s[2,0]=0
		s[2,1]=1
		
		s[3,0]=1
		s[3,1]=0

		Repeat
			
			For z = EachIn punktliste
				For i = 0 To 3
					mx=s[i,0]+z.x
					my=s[i,1]+z.y
					If mx > -1 And  mx <2048 And my>-1 And my<2048 Then
						If getpos(mx,my)=T Then
							If get_part_of_byte(tmap.array[mx,my],5,5) Shr 2 = 0 Then
								Local g:tpoint = New tpoint
								tmap.array[mx,my]=((tmap.array[mx,my]) + (1 Shl 2))
								g.x=mx
								g.y=my
								punktliste.addlast(g)
							EndIf
						EndIf
					EndIf
				Next
				punktliste.remove(z)
				z=Null
			Next
		Until punktliste.count()=0
	End Function
	
	Function fillwatermap()
		If debug=1 Then Print "L-Fill map with water"
		Local x,y
		Local m,mx,my
		tmap.array[0,0]=((tmap.array[0,0]) + (1 Shl 2))
		Checkpoint(0,0,-1)
		For x = 0 To 2047
			For y = 0 To 2047
				If get_part_of_byte(tmap.array[x,y],5,5) Shr 2 =1 Then
					tmap.array[x,y]=1 Shl 1
				EndIf
			Next
		Next

	End Function

	
	Function getpos(X,Y)
		If x < 0 Or x >2047 Or y<0 Or y>2047 Then
			Return 0
		Else
			If (get_part_of_byte(tmap.array[x,y],7,7)) Then
				Return 1
			Else
				Return -1
			EndIf
		EndIf
	End Function
	
	'Speichern der Map
	Function Savemap(file$="map.txt",ts=0,te=7)
		Local x%,y%
		Local outfile:TStream = WriteFile(file)
		For x = 0 To 2047
			Local raus$ = ""
			For y = 0 To 2047
				raus = raus + (get_part_of_byte(tmap.array[x,y],ts,te) Shr (7-te))
			Next
			WriteLine outfile,raus$
		Next
		CloseFile outfile
	End Function
	
	Function Loadtype(Typ%)
		Local in:TStream=ReadFile("map.txt")
		
		VMapWeganz%=Int(ReadLine(in))
		VMapWegminlaenge%=Int(ReadLine(in))
		VMapWegmaxlaenge%=Int(ReadLine(in))
		VMapWegminbreite%=Int(ReadLine(in))
		VMapWegmaxbreite%=Int(ReadLine(in))
		VMapRaumgroesse%=Int(ReadLine(in))
		VMapRaumheufigkeit%=Int(ReadLine(in))
		If debug=1 Then
			Print "I-Ini Auslesung:"
			Print "I-Wegdaten: "+ VMapWegmaxlaenge% + " "+ VMapWegminlaenge% + " " + VMapWegminbreite% + " - " + VMapWegmaxbreite%
			Print "I-Raumdaten: "+ VMapRaumgroesse% + " x "+VMapRaumheufigkeit%
		EndIf
		CloseFile in
	EndFunction
	
	Function draw(X,Y,S,W)
		
		Local a,b,c,d,e,f,g,h
		b=x/64-2
		c=(x+s)/64+2
		e=y/64-2
		f=(y+w)/64+2
		For a=b To c
			For d=e To f
				If (a>-1 And a< 2048 And d>-1 And d< 2048) Then
					g= get_part_of_byte(tmap.array[a,d],5,6) Shr 1
					h= get_part_of_byte(tmap.array[a,d],0,4) Shr 3
					Ttiles.draw(a,d,g,h,getpos(a,d))
				EndIf
			Next
		Next
	End Function
EndType


Function get_part_of_byte:Byte(in:Byte,anfang=0,ende=7)
	Local i:Byte
	i=in Shl anfang
	i=i Shr anfang
	i=i Shr (7-ende)
	i=i Shl (7-ende)
	Return i
End Function


Tapp.init()
Tapp.laden()
Tapp.run()

Type Tapp
	Global x,y,z,h,t:ttimer,px,py
	Global player:tfigur
	Global ende
	Function init()
		SeedRnd(MilliSecs())
		If debug=1 Then Print "Load config.txt"
		Local einst:TStream=ReadFile("config.txt")
		x=Int(ReadLine(einst))
		y=Int(ReadLine(einst))
		z=Int(ReadLine(einst))
		h=Int(ReadLine(einst))
		If debug=1 Then Print "init Graphics"
		Graphics(x,y,z,h)
		SetBlend(ALPHABLEND)
		AutoMidHandle(1)
		t=CreateTimer(50)
		HideMouse()
	End Function
	Function laden()
		Local i%
		ladeb(0,"Tiles")
		Ttiles.Grafik[1]=LoadImage("wasser.png")
		Ttiles.Grafik[0]=LoadImage("erde.png")
		Ttiles.Grafik[3]=LoadImage("sand.png")
		Ttiles.Grafik[2]=LoadImage("gras.png")
		Ttiles.Grafik[4]=LoadImage("baum.png")
		Ttiles.Grafik[5]=LoadImage("blatt.png")
		ladeb(3,"Figuren")
		tfigur.grafik[0]=LoadImage("figur1.png")
		tfigur.grafik[1]=LoadImage("figur2.png")
		tfigur.grafik[2]=LoadImage("figur3.png")
		tfigur.grafik[3]=LoadImage("figur4.png")
		tfigur.grafik[4]=LoadImage("figur5.png")
		tfigur.grafik[5]=LoadImage("figur1.png")
		ladeb(6,"Schuesse")
		tshot.grafik[0]=LoadImage("shoot.png")
		tshot.grafik[1]=LoadImage("plasma.png")
		tshot.grafik[2]=LoadImage("laser.png")
		tshot.grafik[3]=LoadImage("letzter.png")
		For i = 0 To 7
			tshot.grafik[i+4]=LoadImage("fire"+i+".png")
		Next
		ladeb(9,"Blut wird abgezapft")
		tblood.grafik=LoadImage("blood.png")
		ladeb(13,"Item")
		titem.grafik[0]=LoadImage("firstaid.png")	
		titem.grafik[1]=LoadImage("secaid.png")		
		titem.grafik[2]=LoadImage("shell1.png")		
		titem.grafik[3]=LoadImage("shell3.png")		
		titem.grafik[4]=LoadImage("shell4.png")		
		titem.grafik[5]=LoadImage("shell5.png")		
		titem.grafik[6]=LoadImage("shell2.png")		
		ladeb(20,"Erstelle Map")
		Tmap.Create()
		ladeb(25,"Runde Ecken")
		tmap.smoothmap(1,1)
		ladeb(35,"Begehe Map")
		tmap.checkmap()
		ladeb(40,"Fuelle Ozeane")
		tmap.fillwatermap()
		ladeb(55,"Dekoriere Umgebung")
		tmap.dekoratemap()
		ladeb(70,"Suche Waelder")
		tmap.bereichmap()
		ladeb(80,"Sounds werden aufgenommen")
		For i=0 To 4
			Tshot.sound[i]=LoadSound("s"+(i+1)+".ogg")
		Next
		ladeb(85,"Leute sterben nicht lautlos!")
		tfigur.sound=LoadSound("t.ogg")
		ladeb(88,"Gegner werden geboren")
		Local sx,sy
		For i = 0 To 3000
			Repeat
				sx=Rand(2048)
				sy=Rand(2048)
			Until tmap.getpos(sx,sy)=1
			Tfigur.neu(sx*64-32,sy*64-32,Rand(0,5))
		Next
		ladeb(90,"Items werden verloren")
		For i = 0 To 5000
			Repeat
				sx=Rand(2048)
				sy=Rand(2048)
			Until tmap.getpos(sx,sy)=1
			Titem.neu(sx*64-32,sy*64-32,Rand(0,6))
		Next
		ladeb(90,"Maps speichern")
		Tmap.savemap("mapall.map")
		Tmap.savemap("mapcol.map",7,7)
		Tmap.savemap("maptyp.map",5,6)
		Tmap.savemap("maphight.map",0,4)
	End Function
	Function ladeb(proz%,txt$)
		Cls
		SetColor(128,128,128)
		DrawText ("Loading Wideworld",5,5)
		DrawText ("Blitzforum.de (BCC 38 - Mapcreation)",5,25)
		DrawRect(20,y/2-20,x-40,40)
		Local m%=255/100.0*proz
		SetColor(255-m,m,0)
		DrawRect(21,y/2-19,x-38,38)
		SetColor(255,255,255)
		DrawText("Lade: "+txt$,x/2-100,y/2+25)
		DrawText("Steuere die braune Figur in der Mitte",0,y/2+50)
		DrawText("mit WASD oder Pfeiltasten",0,y/2+70)
		DrawText("Maus zum drehen und schieen",0,y/2+90)
		DrawText("(Linke Maustaste kann gedrckt gehalten werden)",0,y/2+110)
		DrawText("Die Figuren mit der Lebensanzeige sind Gegener, der Rest Items",0,y/2+130)
		DrawText("1-5 Waffenauswahl",0,y/2+150)
		DrawText("Oben links, 1. Balken Leben,",0,y/2+170)
		DrawText("Oben links, 2.-6. Balken Munition fr die Waffen",0,y/2+190)
		DrawText("Die Datei map.txt enthllt die Parameter fr die Map (readme.txt)",0,y/2+230)
		Flip
	End Function
	Function run()
		Local sx,sy,t1,t2
		Repeat
			sx=Rand(2048)
			sy=Rand(2048)
		Until tmap.getpos(sx,sy)=1
		player = Tfigur.neu(sx*64-32,sy*64-32,0)
		player.hp=1000
		For sx=0 To 4
			player.weapons[sx]=-1
		Next
		player.weapons[0]=1000
		player.weapon=0;
		MoveMouse(x/2,y/2)
		Repeat
			
			'WaitTimer(t)
			Cls
			If KeyDown(key_up) Or KeyDown(key_w) Then player.move(0,3)
			If KeyDown(key_down) Or KeyDown(key_s) Then player.move(0,-2)
			If KeyDown(key_left) Or KeyDown(key_a) Then player.move(-3,0)
			If KeyDown(key_right) Or KeyDown(key_d) Then player.move(3,0)
			If KeyDown(key_1) Then player.weapon=0
			If KeyDown(key_2) Then player.weapon=1
			If KeyDown(key_3) Then player.weapon=2
			If KeyDown(key_4) Then player.weapon=3
			If KeyDown(key_5) Then player.weapon=4
			If MouseDown(1) Then tshot.neu(player.x,player.y,-player.side,player.weapon,player)
			If KeyDown(key_enter) Then tshot.neu(player.x,player.y,-player.side,0)
			If KeyHit(Key_escape) Then ende=2
			player.side=player.side+MouseX()-x/2
			MoveMouse(x/2,y/2)
			px=player.x-x/2
			py=player.y-y/2
			SetRotation(0)
			tmap.draw(px,py,x,y)
			tblood.draw()
			SetColor 255,255,255
			titem.all()
			tfigur.all()
			tshot.all()
			drawhub()
			't1=t2
			't2=MilliSecs()
			'DrawText(1000/(t2-t1),0,0)
			Flip
		Until (ende)
		Repeat
		Cls
		SetColor(255,255,255)
		SetScale(5,5)
		DrawText("Score: "+tapp.player.ep,x/2,y/2)
		Flip
		Until KeyHit(Key_enter) Or KeyHit(Key_space)
	End Function
	Function drawhub()
		SetRotation(0)
		SetColor(192,192,192)
		'DrawRect(0,0,300,120)
		Local m#=player.hp/1000*255
		SetColor(m,255-m,128)
		DrawRect(20,1,m,18)
		Local i
		For i = 0 To 4
			m#=player.weapons[i]/1000.0*255.0
			SetColor(m,255-m,128)
			DrawRect(20,21+i*20,m,18)
			DrawText("W"+(i+1)+":",0,i*20+22)
		Next
		DrawText("HP:",0,0)
	End Function
End Type

Type TTiles
	Global grafik:TImage[6]
	Function draw(X,Y,Z,A,C)
		If C= -1 Then
			A=16
			If Not(z=1) Then z=4
		EndIf
		
		SetColor(30+A*8,30+A*8,30+A*8)
		DrawImage(grafik[Z],X*64-tapp.px,Y*64-tapp.py)
		SetAlpha(0.5)
		SetScale(0.25,1)
		DrawImage(grafik[Z],X*64-tapp.px-40,Y*64-tapp.py)
		SetScale(1,0.25)
		DrawImage(grafik[Z],X*64-tapp.px,Y*64-tapp.py-40)
		SetScale(1,1)
		SetAlpha(1)
	End Function
End Type


Type Tfigur
	Field HP#
	Field X#
	Field Y#
	Field T%,Time%,EP%
	Field Art%
	Field Side%
	Field weapons[5]
	Field weapon
	
	Global sound:TSound
	Global grafik:TImage[6]
	Global liste:TList
	Function neu:tfigur(x%=1,y%=1,Art=1)
		If Tfigur.liste=Null Then tfigur.liste=New TList
		Local figur:Tfigur=New Tfigur
		Tfigur.liste.addlast(figur)
		figur.x=x
		figur.y=y
		figur.art=art
		figur.hp=100
		figur.weapon=Rand(0,4)
		figur.weapons[figur.weapon] = 100000
		Return figur
	End Function
	Function all()
		SetColor 255,255,255
		Local f:tfigur
		For f = EachIn tfigur.liste
			f.update()
		Next
	End Function
	
	Method update()
		Local  i
		Local f:Tfigur=Self
		If f <> tapp.player Then
			If hp < 0 Then
				tfigur.liste.remove(Self)
				For i= 0 To 50
					tblood.neu(x,y)
				Next
				PlaySound(sound)
				tapp.player.ep=tapp.player.ep+10
			EndIf
			If (tapp.player.x-x)^2+(tapp.player.y-y)^2 < 1000000 Then ' Gegner ist in der Nhe.
				Select art
					Case 1
						side=(side+ATan2(tapp.player.y-y,tapp.player.x-x)+90)/2.0
					Case 2
						side=(side+ATan2(tapp.player.y-y,tapp.player.x-x)+90)/2.0
						move(0,-1)
					Case 3
						side=ATan2(tapp.player.y-y,tapp.player.x-x)+90
						move(0,-1)
					Case 4
						side=ATan2(tapp.player.y-y,tapp.player.x-x)+90
						move(-1,0)
					Case 5
						side=ATan2(tapp.player.y-y,tapp.player.x-x)+90
						Local u=Int(MilliSecs()/1000) Mod 3
						Select u
							Case 0
								move(-3,0)
							Case 1
								move(2,-2)
							Case 2
								move(3,1)
						EndSelect
				End Select
				If x-tapp.px>-32 And x-tapp.px<tapp.x+32 And y-tapp.py>-32 And y-tapp.py<tapp.y+32 Then
					tshot.neu(x,y,-side,weapon,f)
				EndIf
				f.draw(1)
				
			EndIf
		Else
			If hp < 0 Then
				Tapp.ende=1
			EndIf
			f.draw(0)
		EndIf
		
	End Method
	
	Method draw(pfeil=0)
		SetRotation(side)
		'Local m%=ep/1000000.0*255.0
		'SetColor(m,255-m,128)
		SetColor(255,255,255)
		DrawImage(grafik[art],x-tapp.px,y-tapp.py)
		SetRotation(0)

		
		If pfeil Then
			SetColor(255,0,0)
			DrawRect(x-tapp.px-51,y-tapp.py-48,102,16)
			SetColor(0,255,0)
			DrawRect(x-tapp.px-50,y-tapp.py-47,hp,14)
			Local u=ATan2(tapp.player.y-y,tapp.player.x-x)
			DrawLine(tapp.px/2+70*Sin(u),tapp.py/2+70*Cos(u),tapp.px/2+100*Sin(u),tapp.py/2+100*Cos(U))
		EndIf
		'If ep > 1000000 Then ep=10000000
	End Method
	Method move(lX,lY)
		Local nx#,ny#
		nx=x-ly*Cos(side+90)+lx*Cos(side)
		ny=y-ly*Sin(side+90)+lx*Sin(side)
		If tmap.getpos((nx+32)/64,(ny+32)/64) = -1 Then
			If tmap.getpos((nx+32)/64,(y+32)/64) = 1 Then
				x=nx
			Else If tmap.getpos((x+32)/64,(ny+32)/64) = 1
				y=ny
			EndIf
		Else
			x=nx
			y=ny
		EndIf
	End Method
End Type

Type TItem
	Field X,Y,Art,r
	Global Grafik:TImage[7]
	Global liste:TList
	Function neu(X,Y,Art)
		If Titem.liste=Null Then Titem.liste=New TList
		Local n:Titem=New titem 'T-Item nicht Titen!
		Titem.liste.addlast(n)
		n.x=x
		n.y=y
		n.art=art
		n.r=Rand(360)
	End Function
	Function all()
		Local n:titem
		For n = EachIn titem.liste
			SetRotation(n.r)
			DrawImage(grafik[n.art],n.x-tapp.px,n.y-tapp.py)
			If ((tapp.player.x-n.x)^2+(tapp.player.y-n.y)^2)<4000 Then
				Select n.art
					Case 0
						tapp.player.hp = tapp.player.hp+50
					Case 1
						tapp.player.hp = tapp.player.hp+250
					Default
						tapp.player.weapons[n.art-2]=tapp.player.weapons[n.art-2]+500/(n.art-1)
				EndSelect
				tapp.player.ep=tapp.player.ep+1
				titem.liste.remove(n)
			EndIf
		Next
	End Function
EndType

Type tshot
	Field x#,y#,s#,t,art,g,r,hp,f:Tfigur
	Global list:TList
	Global grafik:TImage[13]
	Global sound:TSound[5]
	Global time

	Function neu:tshot(X,Y,S,a=0,fig:tfigur=Null)
		If list=Null Then list=New TList
		Local los
		Select a
			Case 0
				If MilliSecs()-fig.time > 50 Then
					los=1
					fig.time=MilliSecs()
				EndIf
			Case 1
				If MilliSecs()-fig.time > 150 Then
					los=1
					fig.time=MilliSecs()
				EndIf
			Case 2
				If MilliSecs()-fig.time > 500 Then
					los=1
					fig.time=MilliSecs()
				EndIf
			Case 3
				If MilliSecs()-fig.time > 2000 Then
					los=1
					fig.time=MilliSecs()
				EndIf
			Case 4
				los=Rand(0,15)
		End Select
		If fig.weapons[fig.weapon] < 0 Then
			los=0
		Else
			If los = 1 Then
				fig.weapons[fig.weapon]=fig.weapons[fig.weapon]-1
			EndIf
		EndIf
		If los=1 Then
			PlaySound(sound[fig.weapon])
			Local n:tshot = New tshot
			list.addlast(n)
			If fig=Null Then fig =tapp.player
			n.f=fig
			n.x=x
			n.y=y
			n.s=s+180
			n.r=n.s
			n.t=MilliSecs()
			n.art=a
			n.g=a
			Select a
				Case 0
					n.s=n.s+Rand(-5,5)
					n.hp=3
				Case 1
					n.s=n.s
					n.r=Rand(360)
					n.hp=6
				Case 2
					n.s=n.s
					n.r=Rand(360)
					n.hp=9
				Case 3
					n.s=n.s
					n.r=Rand(360)
					n.hp=1
				Case 4
					n.g=4+Rand(0,7)
					n.r=Rand(360)
					n.hp=12
			End Select
			Return n
		EndIf
	End Function
	Method draw()
		SetRotation(-r)
		
		'SetAlpha((2000.0-(MilliSecs()-t))/2000.0)
		DrawImage(grafik[g],x-tapp.px,y-tapp.py)
	End Method
	Method update()
		Local fig:Tfigur
		Select art
		Case 0
			x=x+Sin(s)*8
			y=y+Cos(s)*8
		Case 1
			x=x+Sin(s)*3
			y=y+Cos(s)*3
		Case 2
			s=s+(t-MilliSecs())/100.0
			x=x+Sin(s)*7
			y=y+Cos(s)*7
		Case 3
			x=x+Sin(s)*3
			y=y+Cos(s)*3
			Tshot.neu(X,Y,Rand(360),0,f)
		Case 4
			s=s+Rnd(-2,2)
			x=x+Sin(s)*(2000.0-(t-MilliSecs()))/2000.0*5.0
			y=y+Cos(s)*(2000.0-(t-MilliSecs()))/2000.0*5.0
		End Select
		For fig=EachIn Tfigur.liste
			If Not(f = fig) Then
				If ((x-fig.x)^2+(y-fig.y)^2)<1024 Then
					fig.hp = fig.hp-hp
					If fig.hp< 0 Then 
						For t=0 To 50
							tblood.neu(fig.X,fig.Y)
						Next
					EndIf
					t=0
					tblood.neu(X,Y)
				EndIf
			EndIf
		Next
		If MilliSecs()-t > 2000 Then
			list.remove(Self)
		EndIf
	EndMethod
	Function all()
		Local n:tshot
		'SetBlend(LIGHTBLEND)
		SetBlend(ALPHABLEND)
		SetAlpha(1)
		SetColor(255,255,255)
		If Not(list = Null) Then
			For n= EachIn list
				n.update()
				n.draw()
			Next
		EndIf
		'SetBlend(ALPHABLEND)
		SetAlpha(1)
	End Function
EndType

Type Tblood
	Field X,Y,R,s#
	Global Liste:TList
	Global grafik:TImage
	Function neu(X,Y)
		If Rand(24)= 1 Then
			Local m:Tblood = New tblood
			If tblood.liste= Null Then tblood.liste=New TList
			Tblood.liste.addlast(m)
			m.x=x+Rnd(-32,64)
			m.y=y+Rnd(-32,64)
			m.r=Rand(360)
			m.s=Rnd(0.1,1)
		EndIf
	End Function
	Function draw()
		SetBlend(LIGHTBLEND)
		Local m:Tblood
		If tblood.liste=Null Then tblood.liste=New TList
		SetColor(255,0,0)
		SetAlpha(0.5)
		For m= EachIn Tblood.liste
			If m.x-tapp.px>-64 And m.x-tapp.px<tapp.x+64 And m.y-tapp.py>-64 And m.y-tapp.py<tapp.y+64 Then
				SetScale(m.s,m.s)
				SetRotation(m.r)
				DrawImage(grafik,m.x-tapp.px,m.y-tapp.py)
			EndIf
		Next
		SetBlend(Alphablend)
		SetAlpha(1)
		SetScale(1,1)
		SetRotation(0)
	End Function

End Type




