Const G_WIDTH  = 800
Const G_HEIGHT = 600


Graphics G_WIDTH,G_HEIGHT,0,2
SeedRnd MilliSecs()
SetBuffer BackBuffer()
HidePointer()


Const TILE_MIN_DARKNESS = 5
Const TILE_MAX_DARKNESS = 20
Const TILE_DARKNESS_M = 10

Const SCHUSS_SPEED = 4
Const TIME_FOR_NEXT_SHOT = 2


;SETTINGS;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Global COUNT_ENEMIES = 10

Global MAPSIZE = 199
Global COUNT_CIRCLES = 180

Global SECONDS_SHIELD = 2

Global PLAYER_HITPOINTS = 10
Global ENEMY_HITPOINTS = 4


Global opt$[5]
opt[0] = "Anzahl Gegner"
opt[1] = "Mapgroesse"
opt[2] = "Anzahl Gegenstaende"
opt[3] = "Schildsekunden"
opt[4] = "Lebenspunkte Spieler"
opt[5] = "Lebenspunkte Gegner"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;-MENU ARRAY-;
Dim menu$(2,1)

menu(0,0) = "Start"
menu(1,0) = "Optionen"
menu(2,0) = "Ende"


;-MAP ARRAY-;
Dim map(399,399,50)	; <- Maximalwerte


;-ENEMY TYPE-;
Type enemy
	Field x#, y#
	Field ox, oy
	Field ox2, oy2
	Field w#, ls_time
	Field path_ID
	Field r, g, b
	Field HP
End Type

Global e.enemy

Global enemies_left

;-SCHUSS TYPE-;
Type schuss
	Field x#, y#
	Field w#
End Type

Global s.schuss

;-GENERAL THINGS-;
Global timer = CreateTimer(60)
Global frame

Global win, loss
Global endgame

Global mx, my, md1, mh1
MoveMouse(G_WIDTH/2,G_HEIGHT/2)

Global bigfont   = LoadFont("Arial",60,1)
Global smallfont = LoadFont("Arial",20)

;-MENU THINGS-;
Global menusel
Global optsel
Global optChange


;-PLAYER VARS-;
Global px# , py#
Global opx, opy
Global pw, p_ls_time
Global p_shield_time
Global pHP
Global ox,oy


;-INIT-;
startgame()

;-MAIN LOOP-;
Repeat
	
	Repeat
		
		init_menu()
		
		Repeat
		
			mouse()
			m_text()
			m_draw()
			m_select()
			
			Oval mx-3,my-3,7,7
		
			If mh1 And menusel>0 Then Exit
			
			If KeyHit(1) End
			
			WaitTimer timer
			Flip 0
			Cls
		
		Forever
		
		If menusel = 3 Then End
		If menusel = 2 Then
		
			Repeat
				
				mouse()
				o_draw()
				o_select()
				o_click()
				
				Oval mx-3,my-3,7,7
			
				WaitTimer timer
				Flip 0
				Cls
		
			Until KeyHit(1)
			
		End If
		If menusel = 1 Then Exit
		
	Forever
	
	startgame()
	
	Cls
	
	Repeat
		
		shots()
		
		If frame Mod 3 = 0 Then
			
			scrolling()
			mouse()
			drawmap()
			enemies()
			player()
			hud()
			loose_win()
			
			Flip 0
			Cls
		
		End If
		
		
		If KeyHit(1) Exit

		frame = frame + 1
		WaitTimer timer
		
	Until endgame = 1
	
	
Until KeyHit(1)


End


Function o_click()
;auch hier nochmal tschuldigung fuers hardcoden :<
If mh1 Then optChange = optSel
Select optChange
	Case 1
		COUNT_ENEMIES = Int(inp(COUNT_ENEMIES))
		If COUNT_ENEMIES > 50 Then COUNT_ENEMIES = 50
	Case 2
		MAPSIZE = Int(inp(MAPSIZE))
		If MAPSIZE > 399 Then MAPSIZE = 399
	Case 3
		COUNT_CIRCLES = Int(inp(COUNT_CIRCLES))
	Case 4
		SECONDS_SHIELD = Int(inp(SECONDS_SHIELD))
	Case 5
		PLAYER_HITPOITNTS = Int(inp(PLAYER_HITPOINTS))
	Case 6
		ENEMY_HITPOINTS = Int(inp(ENEMY_HITPOINTS))
End Select
If KeyHit(28) Then optChange = 0
End Function


Function o_select()
If optChange = 0 Then
	For i = 0 To 5
		If my > 216 + i * 32 And my < 232 + i * 32 Then optsel = i+1
	Next
End If
End Function


Function o_draw()
Color 255,255,255

SetFont bigfont
Text G_WIDTH/2, 30, "Random Arena", 1, 1

SetFont smallfont
Text G_WIDTH/2, 60, "by Tennisball", 1, 1

;sorry fuers hardcoden :(
If optsel = 1 Then Color 0,0,200 : Else Color 255,255,255
Text G_WIDTH/2, 216, opt[0] + " : " + COUNT_ENEMIES , 1
If optsel = 2 Then Color 0,0,200 : Else Color 255,255,255
Text G_WIDTH/2, 248, opt[1] + " : " + MAPSIZE , 1
If optsel = 3 Then Color 0,0,200 : Else Color 255,255,255
Text G_WIDTH/2, 280, opt[2] + " : " + COUNT_CIRCLES , 1
If optsel = 4 Then Color 0,0,200 : Else Color 255,255,255
Text G_WIDTH/2, 312, opt[3] + " : " + SECONDS_SHIELD , 1
If optsel = 5 Then Color 0,0,200 : Else Color 255,255,255
Text G_WIDTH/2, 344, opt[4] + " : " + PLAYER_HITPOINTS , 1
If optsel = 6 Then Color 0,0,200 : Else Color 255,255,255
Text G_WIDTH/2, 376, opt[5] + " : " + ENEMY_HITPOINTS , 1
;end hardcoding

Color 255,255,255
End Function


Function m_select()
If my > 240 And my < 260 Then menusel = 1
If my > 310 And my < 330 Then menusel = 2
If my > 380 And my < 400 Then menusel = 3
If my < 240 Or  my > 400 Then menusel = 0
End Function


Function m_draw()
Color 255,255,255

SetFont bigfont
Text G_WIDTH/2, 30, "Random Arena", 1, 1

SetFont smallfont
Text G_WIDTH/2, 60, "by Tennisball", 1, 1

For i = 0 To 2
	If menusel = i+1 Then Color 0,0,200 : Else Color 255,255,255
	Text G_WIDTH/2, 250 + i * 70, menu(i,1), 1, 1
Next

Color 255,255,255
End Function


Function m_text()
Local newtext$
Local char$

For i = 0 To 2
	newtext = ""
	For j = 1 To Len(menu(i,0))
		char = Mid(menu(i,0),j,1)
		If Asc(Mid(menu(i,1),j,1)) > Asc(Mid(menu(i,0),j,1)) Then char$ = Chr(Asc(Mid(menu(i,1),j,1))-1)
		If Asc(Mid(menu(i,1),j,1)) < Asc(Mid(menu(i,0),j,1)) Then char$ = Chr(Asc(Mid(menu(i,1),j,1))+1)
		newtext = newtext + char
	Next
	menu(i,1) = newtext
Next
End Function


Function loose_win()
If win = 1 Or loss = 1 Then
	SetFont bigfont
	If win=1 And loss=0 Then Color 0,200,0 : Text G_WIDTH/2-ox, G_HEIGHT/2-oy, "You win!!", 1, 1
	If win=0 And loss=1 Then Color 200,0,0 : Text G_WIDTH/2-ox, G_HEIGHT/2-oy, "You loose!!", 1, 1
	If win=1 And loss=1 Then Color 200,200,0 : Text G_WIDTH/2-ox, G_HEIGHT/2-oy, "Draw.", 1, 1
	Flip
	FlushKeys()
	Repeat : Until KeyHit(28)
	endgame = 1
End If
End Function


Function init_menu()
FlushMouse()
Origin 0,0
ox = 0
oy = 0
For i = 0 To 2
	menu(i,1) = ""
	For j = 1 To Len(menu(i,0))
		menu(i,1) = menu(i,1) + Chr(Rand(33,126))
	Next
Next
End Function


Function startgame()
win = 0
loss = 0
endgame = 0

Delete Each enemy
Delete Each schuss

For i = 1 To COUNT_ENEMIES
	e = New enemy
	e\path_ID = i
	e\g = Rand(0,100)
	e\r = Rand(60,75) * 3
	e\b = Rand(0,100)
	e\HP = ENEMY_HITPOINTS
Next

enemies_left = COUNT_ENEMIES

createmap()
For e = Each enemy
	fp_astar(e\x,e\y,e\path_ID)
Next

p_shield_time = SECONDS_SHIELD * 30
pHP = PLAYER_HITPOINTS
End Function


Function hud()
Color 255,0,0
Rect px*6, py*6-3, 6 , 2
Color 0,255,0
Rect px*6, py*6-3, 6 * pHP / PLAYER_HITPOINTS, 2
End Function


Function mouse()
mx  = MouseX()-ox
my  = MouseY()-oy
md1 = MouseDown(1)
mh1 = MouseHit(1)
End Function


Function scrolling()
ox = 0-px*6+G_WIDTH  / 2
oy = 0-py*6+G_HEIGHT / 2

Origin ox,oy
End Function


Function player()
If KeyDown(203) Or KeyDown(30) If px > 0       If map(px-1,py,0) = 0 Then px = px - 1
If KeyDown(205) Or KeyDown(32) If px < MAPSIZE If map(px+1,py,0) = 0 Then px = px + 1
If KeyDown(200) Or KeyDown(17) If py > 0       If map(px,py-1,0) = 0 Then py = py - 1
If KeyDown(208) Or KeyDown(31) If py < MAPSIZE If map(px,py+1,0) = 0 Then py = py + 1

If p_shield_time > 0 Then p_shield_time = p_shield_time - 1
Color 255,255,255
If p_shield_time > 0 Then Oval px*6-4,py*6-4,14,14,0


pw = ATan2(my-py*6,px*6-mx)

p_ls_time = p_ls_time + 1
If p_shield_time = 0  And p_ls_time >= TIME_FOR_NEXT_SHOT And md1 Then
	s = New schuss
	s\x = px*6+1-Cos(pw)*5
	s\y = py*6+1+Sin(pw)*5
	s\w = pw
	p_ls_time = 0
End If


Color 0,0,255
Rect px*6,py*6,6,6
Oval mx-5,my-5,11,11,0
Line mx-5,my,mx+5,my
Line mx,my-5,mx,my+5
Line px*6+3,py*6+3,px*6+3-Cos(pw)*10,py*6+3+Sin(pw)*10
End Function


Function drawmap()
For x = 0 To MAPSIZE
	For y = 0 To MAPSIZE
		Color 255-map(x,y,0)*TILE_DARKNESS_M,255-map(x,y,0)*TILE_DARKNESS_M,255-map(x,y,0)*TILE_DARKNESS_M
		If map(x,y,0) > 0 Then Rect x*6,y*6,6,6
	Next
Next
End Function


Function shots()
Color 200,200,200
For s = Each schuss
	del_flag = 0
	
	s\x = s\x - Cos(s\w) * SCHUSS_SPEED
	s\y = s\y + Sin(s\w) * SCHUSS_SPEED
	
	If s\x < 0 Or s\x > MAPSIZE*6 Or s\y < 0 Or s\y > MAPSIZE*6 Then del_flag = 1
	If del_flag = 0 If map(s\x/6,s\y/6,0) > 0 Then
		del_flag = 1
		map(s\x/6,s\y/6,0) = map(s\x/6,s\y/6,0) + 2
		If map(s\x/6,s\y/6,0) > TILE_MAX_DARKNESS Then map(s\x/6,s\y/6,0) = 0
	End If
	For e = Each enemy
		If Int(s\x/6) = e\x And Int(s\y/6) = e\y Then
			e\HP = e\HP - 1
			If e\HP <= 0 Then Delete e : enemies_left = enemies_left - 1
			del_flag = 1
			Exit
		End If
	Next
	If Int(s\x/6) = px And Int(s\y/6) = py Then
		pHP = pHP - 1
		del_flag = 1
		Exit
	End If
	
	If frame Mod 3 = 0 Then
		If del_flag = 0 Then Rect s\x,s\y,2,2
	End If
	
	If del_flag = 1 Then Delete s
Next
If enemies_left = 0 Then win = 1
If pHP <= 0 Then loss = 1
End Function


Function enemies()
For e = Each enemy
	
	e\ls_time = e\ls_time + 1
	If p_shield_time = 0  And e\ls_time >= TIME_FOR_NEXT_SHOT Then
		s = New schuss
		s\x = e\x*6+3-Cos(e\w)*10
		s\y = e\y*6+3+Sin(e\w)*10
		s\w = e\w
		e\ls_time = 0
	End If
	
	If frame Mod 15 = 0 Then
		For x = 0 To MAPSIZE
			For y = 0 To MAPSIZE
				map(x,y,e\path_ID) = 0
			Next
		Next
		fp_astar(e\x,e\y,e\path_ID)
	End If
	
	e\w = ATan2(py-e\y,e\x-px)
		
	e\ox2 = e\ox
	e\oy2 = e\oy
	e\ox  = e\x
	e\oy  = e\y
	If e\x > 0       Then If map(e\x-1,e\y,e\path_ID) = 1 Then map(e\x-1,e\y,e\path_ID) = 0 : e\x = e\x - 1
	If e\y > 0       Then If map(e\x,e\y-1,e\path_ID) = 1 Then map(e\x,e\y-1,e\path_ID) = 0 : e\y = e\y - 1
	If e\y < MAPSIZE Then If map(e\x,e\y+1,e\path_ID) = 1 Then map(e\x,e\y+1,e\path_ID) = 0 : e\y = e\y + 1
	If e\x < MAPSIZE Then If map(e\x+1,e\y,e\path_ID) = 1 Then map(e\x+1,e\y,e\path_ID) = 0 : e\x = e\x + 1
	
	If e\ox = e\x And e\oy = e\y And e\ox2 = e\x And e\oy2 = e\y Then
		For x =-6 To 6
			For y =-6 To 6
				If e\x+x=>0 And e\x+x<=MAPSIZE And e\y+y=>0 And e\y+y<=MAPSIZE Then
					If Sqr((e\x+x-e\x)^2 + (e\y+y-e\y)^2) <= 6 Then map(e\x+x,e\y+y,0) = 0
				End If
			Next
		Next
		For x = 0 To MAPSIZE
			For y = 0 To MAPSIZE
				map(x,y,e\path_ID) = 0
			Next
		Next
	End If
	
	Color 255,0,0
	Rect e\x*6, e\y*6-3, 6 , 2
	Color 0,255,0
	Rect e\x*6, e\y*6-3, 6 * e\hp / ENEMY_HITPOINTS, 2
	
	Color e\r,e\g,e\b
	Rect e\x*6,e\y*6,6,6
	Line e\x*6+3, e\y*6+3, e\x*6+3-Cos(e\w)*10, e\y*6+3+Sin(e\w)*10

Next
End Function


Function createmap()
For x = 0 To MAPSIZE
	For y = 0 To MAPSIZE
		map(x,y,0) = 0
		If x=0 Or y=0 Or x=MAPSIZE Or y=MAPSIZE Then map(x,y,0) = 1
	Next
Next
For i = 0 To COUNT_CIRCLES-1
	mx = Rand(0,MAPSIZE)
	my = Rand(0,MAPSIZE)
	a = Rand(2,10)
	b = Rand(2,10)
	For w = 1 To 360
		x = mx - Cos(w) * a
		y = my + Sin(w) * b
		If x=>0 And y=>0 And x<=MAPSIZE And y<=MAPSIZE Then map(x,y,0) = 1
	Next
	ff(mx,my)
Next

FillGaps()

setplayerstart()

For x = 0 To MAPSIZE
	For y = 0 To MAPSIZE
		If map(x,y,0) = 1 Then map(x,y,0) = Rand(TILE_MIN_DARKNESS,TILE_MAX_DARKNESS)
	Next
Next

End Function

Function FillGaps()
	For x = 0 To MAPSIZE
		For y = 0 To MAPSIZE
			c=0
			If x > 0   If map(x-1,y,0) = 1 Then c = c + 1
			If x < MAPSIZE If map(x+1,y,0) = 1 Then c = c + 1
			If y > 0   If map(x,y-1,0) = 1 Then c = c + 1
			If y < MAPSIZE If map(x,y+1,0) = 1 Then c = c + 1
			
			If c > 2 Then map(x,y,0) = 1
		Next
	Next
End Function

Function ff(x,y)
	map(x,y,0) = 1
	If x > 0   If map(x-1,y,0) = 0 ff(x-1,y)
	If x < MAPSIZE If map(x+1,y,0) = 0 ff(x+1,y)
	If y > 0   If map(x,y-1,0) = 0 ff(x,y-1)
	If y < MAPSIZE If map(x,y+1,0) = 0 ff(x,y+1)
End Function

Function setplayerstart()
Repeat
	px = Rand(0,MAPSIZE)
	py = Rand(0,MAPSIZE)
	If map(px,py,0) = 0 Then ok = 1
Until ok=1

For e = Each enemy
	ok = 0
	Repeat
		e\x = Rand(0,MAPSIZE)
		e\y = Rand(0,MAPSIZE)
		If map(e\x,e\y,0) = 0 Then ok = 1
	Until ok=1
Next
End Function


Function fp_astar(x,y,pID,f=0)
	
	;Kommentar: Das ist kein richtiges A Star!!
	;Das hier ermittelt nur das Feld drumherum, was den kleinsten x+y Abstand zum Ziel hat und berechnet dann einige Bewegungen
	;Sieht vielleicht sehr unordentlich und ineffizient programmiert aus, aber ich hab mich davor auch nicht damit beschaeftigt
	
	Local Min
	Local values[3]
	For i = 0 To 3 : values[i] = 99999999 : Next
	
	If x = px And y = py Then Return 1
	
	If x>0       If map(x-1,y,0) = 0 And map(x-1,y,pID) = 0 Then values[0] = Abs(px-(x-1)) + Abs(py-y)
	If x<MAPSIZE If map(x+1,y,0) = 0 And map(x+1,y,pID) = 0 Then values[1] = Abs(px-(x+1)) + Abs(py-y)
	If y>0       If map(x,y-1,0) = 0 And map(x,y-1,pID) = 0 Then values[2] = Abs(px-x) + Abs(py-(y-1))
	If y<MAPSIZE If map(x,y+1,0) = 0 And map(x,y+1,pID) = 0 Then values[3] = Abs(px-x) + Abs(py-(y+1))
	
	Min = values[0]
	For I = 1 To 3
		If values[I] < Min Then Min = values[I]
	Next
	
	If min = 99999999 Then Return 0
	
	Select min
		Case values[0]
			map(x-1,y,pID) = 1
			If f<20 If fp_astar(x-1,y,pID,f+1) Then Return 1
		Case values[1]
			map(x+1,y,pID) = 1
			If f<20 If fp_astar(x+1,y,pID,f+1) Then Return 1
		Case values[2]
			map(x,y-1,pID) = 1
			If f<20 If fp_astar(x,y-1,pID,f+1) Then Return 1
		Case values[3]
			map(x,y+1,pID) = 1
			If f<20 If fp_astar(x,y+1,pID,f+1) Then Return 1
	End Select
	
End Function


Function inp$(s$)
	key = GetKey()
	If KeyHit(14) Then If Len(s$) > 0 Then s$ = Mid(s$, 1, Len(s$)-1)
	If key => 48 And key <= 57 Then		;numbers only
		s$ = s$ + Chr(key)
	End If
	Return s$
End Function