
Function Auf(Aufquelle,Aufziel,Aufzziel=0,AufWahl=0)
	
	HideEntity Aufquelle
	
	If Aufzziel=0 Then Aufzziel=Aufziel
	
	Select AufWahl
		Case 1
			PositionEntity Aufquelle,EntityX(Aufziel),EntityY(Aufziel),EntityZ(Aufziel),1
		Case 2
			RotateEntity Aufquelle,EntityPitch(Aufzziel),EntityYaw(Aufziel),EntityRoll(Aufziel),1
		Default 
			RotateEntity Aufquelle,EntityPitch(Aufzziel),EntityYaw(Aufziel),EntityRoll(Aufziel),1
			PositionEntity Aufquelle,EntityX(Aufziel),EntityY(Aufziel),EntityZ(Aufziel),1
	End Select 
	
	ShowEntity Aufquelle
	
End Function


SeedRnd MilliSecs()
auflx=1280:aufly=800
timer=CreateTimer(30)
SetBuffer BackBuffer()

lp=2000

Graphics3D auflx,aufly,o,1

Type ding
	Field modell
End Type

Type gegner
	Field modell
	Field lp
End Type

Type waffe
	Field modell
	Field dran
	Field lade
	Field schaden
End Type


;Waffen laden
Wasserpistole=LoadMesh("Zeugs\Wasserpistole.b3d")
ScaleEntity Wasserpistole,0.01,0.01,0.01
SchrotMG=LoadMesh("Zeugs\SchrotMG.b3d")
ScaleEntity SchrotMG,0.01,0.01,0.01
RK=LoadMesh("Zeugs\RK.b3d")
ScaleEntity RK,0.01,0.01,0.01


;Karte erstellen
groesse=500
For x=0 To groesse Step 10
	For y=0 To 100 Step 10
		For z=0 To groesse Step 10
			
			If Rand(0,20)<12 Then
				ding.ding=New ding
				ding\modell=CreateCube()
				ScaleEntity ding\modell,5,5,5
				PositionEntity ding\modell,x,y,z
				EntityColor ding\modell,Rand(0,255),Rand(0,255),Rand(0,255)
				EntityType ding\modell,2
				
			ElseIf Rand(0,20)=1 Then
				waffe.waffe=New waffe
				
				Select Rand(1,3)
					Case 1
						waffe\modell=CopyEntity(Wasserpistole)
						waffe\lade=27
						waffe\schaden=3
					Case 2
						waffe\modell=CopyEntity(SchrotMG)
						waffe\lade=7
						waffe\schaden=1
					Case 3
						waffe\modell=CopyEntity(RK)
						waffe\lade=50
						waffe\schaden=20
				End Select 
				
				PositionEntity waffe\modell,x,y-4,z
				TurnEntity waffe\modell,0,Rand(0,360),0
				
			ElseIf Rand(0,100)=4 Then
				gegner.gegner=New gegner
				gegner\modell=CreateCone()
				EntityColor gegner\modell,0,0,0
				PositionEntity gegner\modell,x,y,z
				EntityType gegner\modell,1
				gegner\lp=Rand(10,40)
			EndIf
			
		Next
	Next
Next

;Entitys erstellen
deckel=CreatePlane()
EntityType deckel,2
MoveEntity deckel,0,100,0
RotateEntity deckel,180,0,0

umr=CreateCube()
ScaleEntity umr,groesse/2+10,60,groesse/2+10
PositionEntity umr,groesse/2+5,55,groesse/2+5
EntityColor umr,0,255,0
FlipMesh umr

kamera=CreateCamera()
CameraViewport kamera,0,0,auflx,aufly

licht=CreateLight(1,kamera)
CameraRange kamera,.1,70

CameraFogMode kamera,1
CameraFogColor kamera,255,255,25
CameraFogRange kamera,30,40
PositionEntity kamera,groesse/2,50,groesse/2
EntityType kamera,1

himmel=CreateSphere(8,kamera)
ScaleEntity himmel,60,60,60
FlipMesh himmel

boden=CreatePlane()
EntityColor boden,255,0,0
EntityAlpha boden,0.85

schuss=CreateSphere()
EntityColor schuss,0,0,0
ScaleEntity schuss,0.1,0.1,0.1

;Kollision
Collisions 1,2,2,2

zk=LoadImage("Zeugs\zk.png")
ResizeImage zk,auflx,aufly

anfangszeit=MilliSecs()
While Not KeyHit(1)
	
	For ding.ding=Each ding
		If EntityDistance (ding\modell,kamera)<70 Then
			ShowEntity ding\modell
		Else
			HideEntity ding\modell
		EndIf
	Next
	
	
	;;Waffenkontrolle
	If MouseHit(2) Then 
		mdr=1
	Else
		mdr=0
	EndIf
	
	For waffe.waffe=Each waffe
		If EntityDistance (waffe\modell,kamera)<70 Then
			ShowEntity waffe\modell
			If EntityDistance(waffe\modell,kamera)<5 And mdr=1 And waffe\dran=0 Then
				For waffej.waffe=Each waffe 
					waffej\dran=0
					EntityParent waffej\modell,0
				Next
				waffe\dran=1
				EntityParent waffe\modell,kamera
			EndIf
			
			If waffe\dran=1 And MouseDown(1) And wz=0 Then
				Auf(schuss,kamera)
				schaden=waffe\schaden
				wz=1
			EndIf
			
			If waffe\dran=1 And wz>=waffe\lade Then wz=0
			
				
		Else
			HideEntity waffe\modell
		EndIf
	Next
	
	If wz>0 Then wz=wz+1
	
	MoveEntity schuss,0,0,1
	
	
	;;Gegnerkontrolle
	For gegner.gegner=Each gegner
		If EntityDistance (gegner\modell,kamera)<70 Then
			ShowEntity gegner\modell
			If EntityDistance(gegner\modell,schuss)<4 Then gegner\lp=gegner\lp-schaden
			If EntityDistance (gegner\modell,kamera)<3 Then lp=lp-4
		Else
			HideEntity gegner\modell
		EndIf
		
		If gegner\lp<=0 Then
			FreeEntity gegner\modell:Delete gegner.gegner 
		EndIf
	Next
	
	If EntityY(kamera)<0 Then lp=lp-10
	
	
	;;Verloren/Gewonnen
	If lp<=0 Then 
		Cls 
		font=LoadFont("Arial",180)
		SetFont font
		Text 150,150,"Verloren!"
		Flip
		FlushKeys()
		WaitKey()
		End
	EndIf
	
	If EntityZ(kamera)<0-5 Or EntityZ(kamera)>groesse+5 Or EntityX(kamera)<0-5 Or EntityX(kamera)>groesse+5 Then
		Cls 
		font=LoadFont("Arial",120)
		SetFont font
		Text 150,150,"Gewonnen!"
		Text 10,300,"Zeit: "+(MilliSecs()-anfangszeit)/1000+" Sekunden"
		Text 20,600,"Lebenspunkte noch: "+lp/20+" %"
		Flip
		FlushKeys()
		WaitKey()
		End
	EndIf
	
	For gegner.gegner=Each gegner 
		If EntityDistance(gegner\modell,kamera)<70 Then 
			PointEntity gegner\modell,kamera
			MoveEntity gegner\modell,0,0,0.37
		EndIf
	Next
	
	EntityColor umr,Rand(0,255),Rand(0,255),Rand(0,255)
	
	;Steuerung
	mxspeed=MouseXSpeed()*0.25
	myspeed=MouseYSpeed()*0.25
	kpitch=kpitch+myspeed
	kyaw=kyaw-mxspeed
	
	MoveMouse GraphicsWidth()/2,GraphicsHeight()/2
	RotateEntity kamera,kpitch,kyaw,0 
	
	If KeyDown(17) Then MoveEntity kamera,0,0,0.5
	If KeyDown(31) Then MoveEntity kamera,0,0,-0.5
	If KeyDown(30) Then MoveEntity kamera,-0.5,0,0
	If KeyDown(32) Then MoveEntity kamera,0.5,0,0
	
	
	
	WaitTimer(timer)
	UpdateWorld 
	RenderWorld 
	Color 255,255,255
	Rect 0,0,202,20,0
	Text 0,20,"LP: "+lp
	Color 255,0,0
	Rect 1,1,lp/10,18
	DrawImage zk,0,0
	
	Flip
Wend
